
import java.awt.*;
import java.applet.Applet;

public class isoperi extends Applet {
    framarea framedArea;
    Label label;
    Graphics g;

    public void init() {
        GridBagLayout gridBag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        setLayout(gridBag);

        framedArea = new framarea(this);
        c.fill = GridBagConstraints.BOTH;
        c.weighty = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER; //end row
        gridBag.setConstraints(framedArea, c);
        add(framedArea);

        label = new Label("Clicka all'interno della figura per spostare il vertice in alto.");
        c.fill = GridBagConstraints.HORIZONTAL;
        c.weightx = 1.0;
        c.weighty = 0.0;
        gridBag.setConstraints(label, c);
        add(label);

        validate();

    }

    public void coordsChanged(Point point) {
        label.setText("Clicka all'interno della figura per spostare il vertice in alto.");
        repaint();
    }
}

class framarea extends Panel {
    public framarea(isoperi controller) {
        super();

        setLayout(new GridLayout(1,0));

        add(new coorarea(controller));
        validate();
    }

    public Insets insets() {
        return new Insets(4,4,5,5);
    }

    public void paint(Graphics g) {
        Dimension d = size();
        Color bg = getBackground();
        Color fg = getForeground();
 
        g.setColor(bg);
        g.draw3DRect(0, 0, d.width - 1, d.height - 1, true);
        g.draw3DRect(3, 3, d.width - 7, d.height - 7, false);
    }
}

class coorarea extends Canvas {
    Point point = null;
    isoperi controller;

    public coorarea(isoperi controller) {
        super();
        this.controller = controller;
    }

    public boolean mouseDown(Event event, int x, int y) {
        if (point == null) {
            point = new Point(x, y);
        } else {
            point.x = x;
            point.y = y;
        }
        controller.coordsChanged(point);
        repaint();

        return false;
    }


    public void draw_Line(Graphics g, int x1, int y1, int x2, int y2, 
			  int si, int no) {
	double d;
	int i,n;
 
	g.drawLine(x2, y2, x2, y2);
	d=Math.sqrt((double)(x2-x1)*(x2-x1)+(double)(y2-y1)*(y2-y1));
	n=(int)(d/(float)(si+no))+1;
	for(i=1; i<n; i++) {
	    g.drawLine( (int)(x1+(i-1)*(si+no)/(double)d*(x2-x1)),
			(int)(y1+(i-1)*(si+no)/(double)d*(y2-y1)),
			(int)(x1+(i*si+(i-1)*no)/(double)d*(x2-x1)),
			(int)(y1+(i*si+(i-1)*no)/(double)d*(y2-y1)));
	}
    }


    public void paint(Graphics g) {
	Dimension d = size();
	double p=4.81354,q1,q2;
        String s;

	g.drawLine(d.width/3, d.height-25, 2*d.width/3, d.height-25);
	draw_Line(g, d.width/2, d.height-125, d.width/3, d.height-25, 4, 6);
	draw_Line(g, d.width/2, d.height-125, 2*d.width/3, d.height-25, 4, 6);
	draw_Line(g, 5, d.height-125, d.width-5, d.height-125, 3, 6);
	draw_Line(g, 5, d.height-25, d.width-5, d.height-25, 3, 6);
	g.drawString("b", d.width/2, d.height-5);
	g.drawString("Perimetro = ", 50 ,25);


        if (point != null) {
	    g.drawLine(2*d.width/5, d.height-25, 3*d.width/5, d.height-25);
	    g.drawLine(point.x, d.height-125, 2*d.width/3, d.height-25);
	    g.drawLine(d.width/3, d.height-25, point.x, d.height-125);
	    draw_Line(g, point.x, d.height-125, point.x, d.height-25, 5, 5);
	    g.drawString("h", point.x+3, d.height-75);
	    q1=point.x-d.width/3.0;
	    q1=q1*q1+10000;
	    q2=point.x-2.0*d.width/3.0;
	    q2=q2*q2+10000;
	    p=Math.sqrt(q1) + Math.sqrt(q2) + d.width/3.0;
	    p=p*Math.sqrt(3.0/50.0/d.width);
	    g.drawString(Double.toString(p), 130,25);
	}
    }
}
